<?php
/**
 * @author ElisDN <mail@elisdn.ru>
 * @link http://www.elisdn.ru/blog/58/old-posts-promotion-on-twitter
 * @version 1.0
 */

namespace Parser;

class Sitemap
{
	private $html = '';

	public function load($url) {
		$http = curl_init($url);
		curl_setopt($http, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($http);
		$http_status = curl_getinfo($http, CURLINFO_HTTP_CODE);
		curl_close($http);
		$this->html = $result;
		return $http_status == 200;
	}

	public function getUrls() {
		$urls = [];
		if ($this->isSitemapIndex()) {
			foreach ($this->getSitemaps() as $sitemap_url) {
				$sitemap = new Sitemap;
				if ($sitemap->load($sitemap_url)) {
					$urls = array_merge($urls, $sitemap->getUrls());
				}
			}
		} else {
			$matches = [];
			if (preg_match_all('@<loc>(?<url>[^<]*?)</loc>@is', $this->html, $matches)) {
				$urls = $matches['url'];
			}
		}
		return array_unique($urls);
	}

	private function isSitemapIndex() {
		return preg_match('@<sitemapindex[^>]*>@is', $this->html);
	}

	private function getSitemaps() {
		$sitemaps = [];
		$matches = [];
		if (preg_match_all('@<sitemap>[^<]*<loc>(?<url>[^<]*?)</loc>@is', $this->html, $matches)) {
			$sitemaps = $matches['url'];
		}
		return $sitemaps;
	}
}